/**
 * Choice controller with added change function.
 * 
 * Capabilities:
 * -change
 * -set
 * -get
 * -has
 * -unset
 * -continue
 * -continued
 * 
 * @param {string} id Id of the scene.
 * @param {string} key Key of this choice.
 * @param {function} changeFn Change function, called once.
 * @param {function} changeNoteFn Change note function. Should return a global.ui.change.buildNotification() result.
 */
function ChangeController(id, key, changeFn, changeNoteFn) {
    ChoiceController.call(this, id, key);
    this.change = function () {
        var changeId = key + "Change";
        global.kobold.history.doIfNotSet(id, changeId, true, changeFn);
        return changeNoteFn();
    };
}
