/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BarnUnaware(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var runId = "unawareRun";
    var attackId = "unawareAttack";
    var forceId = "unawareForce";

    var toRun = new BarnRun(ctrl);
    var toAttack = new BarnAttack(ctrl);
    var toForce = new BarnForce(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var shirt = ctrl.misc.shirt();
        var bra = ctrl.misc.bra();
        var dick = ctrl.misc.dick();
        var cunt = ctrl.misc.cunt();
        var cuntVirgin = ctrl.misc.cuntVirgin();
        var gender = ctrl.misc.gender();
        var clothes = shirt || pants || underwear;
        ctrl.misc.wearShirt(shirt);
        ctrl.misc.wearPants(pants);
        ctrl.misc.wearUnderwear(underwear);
        var toReturn = `[p]
                            ${clothes ? "You sneakily don your garments once more, the modesty they provide bolstering your courage." : ""}
                            Cassidy is still searching through a stash of various bottles and trinkets, most of which seem to be empty and worthless.
                            She hasn't noticed your escape.
                            The tables have turned.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildRunChoice() {
        var disabled = ctrl.unaware.has() ? "disabled" : "";
        var isSelected = ctrl.unaware.get() === BarnUnawareChoice.RUN;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${runId}" ${disabled}>Run</button>`;

        var tooltip = `Get the hell out of here, as fast as you can.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildAttackChoice() {
        var weapon = ctrl.misc.weapon();
        var disabled = ctrl.unaware.has() || !weapon ? "disabled" : "";
        var isSelected = ctrl.unaware.get() === BarnUnawareChoice.ATTACK;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${attackId}" ${disabled} style="width:160px;">Attack Cassidy</button>`;

        var tooltip;
        if (weapon) {
            tooltip = global.parser.parse(`That [b]bitch[/b] thought she could keep you here against your will? Time for some payback.`);
        } else {
            tooltip = global.parser.parse(`You don't have any weapons to attack the woman with.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        button = `<div class="inlinechoice" style="width:160px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildForceChoice() {
        var str = ctrl.misc.strength();
        var strongEnough = str >= 6;
        var disabled = ctrl.unaware.has() || !strongEnough ? "disabled" : "";
        var isSelected = ctrl.unaware.get() === BarnUnawareChoice.FORCE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${forceId}" ${disabled} style="width: 250px">Force her onto the table</button>`;

        var tooltip;
        if (strongEnough) {
            tooltip = global.parser.parse(`Approach from behind, pick her up and [b]wrestle[/b] the woman onto the table herself.
                                            She may be twice your size, but she doesn't have muscles like you do.`);
        } else {
            tooltip = global.parser.parse(`Requires [b]6 strength[/b].`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildRunChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildAttackChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildForceChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + runId), $("#" + attackId), $("#" + forceId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerRunListener() {
        $("#" + runId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unaware.set(BarnUnawareChoice.RUN);
            loadNextPart(toRun);
        });
    }
    
    /**
     * Adds a listener to the button.
     */
    function registerAttackListener() {
        $("#" + attackId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unaware.set(BarnUnawareChoice.ATTACK);
            loadNextPart(toAttack);
        });
    }
    
    /**
     * Adds a listener to the button.
     */
    function registerForceListener() {
        $("#" + forceId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.unaware.set(BarnUnawareChoice.FORCE);
            loadNextPart(toForce);
        });
    }
    

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "barnUnaware";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.unaware.change();
        part += buildChoice();
        part += toRun.build();
        part += toAttack.build();
        part += toForce.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        toRun.registerListeners();
        toAttack.registerListeners();
        toForce.registerListeners();

        if (ctrl.unaware.has()) {
            return;
        }

        registerRunListener();
        registerAttackListener();
        registerForceListener();
    };
}

var BarnUnawareChoice = {
    RUN: 1,
    ATTACK: 2,
    FORCE: 3
};
