/**
 * Controller for the Underground Cave scene.
 * @param {string} sceneId The id of the scene.
 */
function UndergroundCaveController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = true;
    this.nextSceneName = "NightTwo";
    this.nextFolderName = "Varanar";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ChangeController(id, "arrival", function () {
        global.kobold.status.physical.decrease(10, "Drowning");
        global.kobold.status.mental.decrease(9, "Near-death experience");
        global.kobold.status.stamina.decrease(10, "Drowning");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Drowning", "Health", -10),
            new Change("Near-death experience", "Sanity", -10),
            new Change("Still alive", "Sanity", +1),
            new Change("Underwater crawling", "Stamina", -5),
            new Change("Drowning", "Stamina", -5)
        ]);
    });

    // Actually a reset controller.
    this.surface = new UndoController(id, "surface", function change() {
        var healthBacklog = new ChoiceController(id, "surfaceHealthBacklog");
        var sanityBacklog = new ChoiceController(id, "surfaceSanityBacklog");
        var staminaBacklog = new ChoiceController(id, "surfaceStaminaBacklog");
        var exertionBacklog = new ChoiceController(id, "surfaceExertionBacklog");
        var healthLHBacklog = new ChoiceController(id, "surfaceLHHealthBacklog");
        var sanityLHBacklog = new ChoiceController(id, "surfaceLHSanityBacklog");
        var staminaLHBacklog = new ChoiceController(id, "surfaceLHStaminaBacklog");
        var exertionLHBacklog = new ChoiceController(id, "surfaceLHExertionBacklog");
        healthBacklog.set(global.kobold.status.physical.get());
        sanityBacklog.set(global.kobold.status.mental.get());
        staminaBacklog.set(global.kobold.status.stamina.get());
        exertionBacklog.set(global.kobold.status.exertion.get());
        healthLHBacklog.set(global.kobold.status.physical.lasthit);
        sanityLHBacklog.set(global.kobold.status.mental.lasthit);
        staminaLHBacklog.set(global.kobold.status.stamina.lasthit);
        exertionLHBacklog.set(global.kobold.status.exertion.lasthit);
    }, function changeNote() {
        return "";
    }, function undoChange() {
        var healthBacklog = new ChoiceController(id, "surfaceHealthBacklog");
        var sanityBacklog = new ChoiceController(id, "surfaceSanityBacklog");
        var staminaBacklog = new ChoiceController(id, "surfaceStaminaBacklog");
        var exertionBacklog = new ChoiceController(id, "surfaceExertionBacklog");
        var healthLHBacklog = new ChoiceController(id, "surfaceLHHealthBacklog");
        var sanityLHBacklog = new ChoiceController(id, "surfaceLHSanityBacklog");
        var staminaLHBacklog = new ChoiceController(id, "surfaceLHStaminaBacklog");
        var exertionLHBacklog = new ChoiceController(id, "surfaceLHExertionBacklog");
        global.kobold.status.physical.set(healthBacklog.get());
        global.kobold.status.physical.lasthit = healthLHBacklog.get();
        global.kobold.status.mental.set(sanityBacklog.get());
        global.kobold.status.mental.lasthit = sanityLHBacklog.get();
        global.kobold.status.stamina.set(staminaBacklog.get());
        global.kobold.status.stamina.lasthit = staminaLHBacklog.get();
        global.kobold.status.exertion.set(exertionBacklog.get());
        global.kobold.status.exertion.lasthit = exertionLHBacklog.get();
    });

    this.run = new ChangeController(id, "run", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.decrease(7, "Swimming while exerted");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Swimming", "Stamina", -10),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.stare = new UndoController(id, "stare", function () {
        global.kobold.status.mental.decrease(10, "Being petrified");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Petrification", "Sanity", -6),
            new Change("Panic", "Sanity", -4)
        ]);
    });

    this.relent = new ChangeController(id, "relent", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.enjoy = new ChangeController(id, "enjoy", function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(3, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.analVirgin = false;
                global.kobold.status.mental.increase(4, "Basilisk buttsex");
                global.kobold.status.exertion.increase(20, "Basilisk buttsex");
            }
        } else {
            if (clothingFemale) {
                that.misc.shirt() && global.kobold.inventory.equipment.shirt.stain("Basilisk Cum");
                global.kobold.status.mental.decrease(3, "Thighfucked by basilisk");
                global.kobold.status.exertion.increase(8, "Thighfucked by basilisk");
            } else {
                global.kobold.body.vaginalVirgin = false;
                global.kobold.status.mental.increase(10, "Basilisk sex");
                global.kobold.status.exertion.increase(25, "Basilisk sex");
            }
        }
    }, function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Petrified-thigh-fucked", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Thoroughly rutted", "Sanity", +7),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Ferally buttfucked", "Sexual exhaustion", +20, true)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Pleasure denied", "Sanity", -5),
                    new Change("Petrified-thigh-fucked", "Sexual exhaustion", +8, true)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Excitement", "Sanity", +2),
                    new Change("Thoroughly rutted", "Sanity", +5),
                    new Change("Reached climax", "Sanity", +5),
                    new Change("Only one orgasm", "Sanity", -2),
                    new Change("Bestially bred", "Sexual exhaustion", +20, true),
                    new Change("Reached orgasm", "Sexual exhaustion", +5, true)
                ]);
            }
        }
    });

    this.hate = new ChangeController(id, "hate", function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {

            } else {

            }
        } else {
            if (clothingFemale) {

            } else {

            }
        }
    }, function () {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("TODO", "CHANGE", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("TODO", "CHANGE", +1)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("TODO", "CHANGE", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("TODO", "CHANGE", +1)
                ]);
            }
        }
    });

    function regainRelentChange() {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;

        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.stats.decreaseStat(StatsEnum.AGILITY, 1);
        global.kobold.stats.increaseStat(StatsEnum.ENDURANCE, 1);

        if (dick) {
            if (clothingMale) {
                global.kobold.status.mental.decrease(3, "Sexual frustration");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            } else {
                global.kobold.status.mental.increase(1, "Escaped the cave");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            }
        } else {
            if (clothingFemale) {
                global.kobold.status.mental.decrease(3, "Sexual frustration");
                global.kobold.status.exertion.increase(2, "Sexual frustration");
            } else {
                global.kobold.status.mental.increase(1, "Escaped the cave");
            }
        }
    }

    function regainRelentNote() {
        var dick = that.misc.dick();
        var pants = that.misc.pants();
        var underwear = that.misc.underwear();
        var underwearMale = underwear && underwear.coversRear();
        var underwearFemale = underwear && underwear.coversGroin();
        var clothingMale = underwearMale ? underwear : false;
        clothingMale = pants ? pants : clothingMale;
        var clothingFemale = underwearFemale ? underwear : false;
        clothingFemale = pants ? pants : clothingFemale;
        if (dick) {
            if (clothingMale) {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -6),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -2),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            }
        } else {
            if (clothingFemale) {
                return global.ui.change.buildNotification([
                    new Change("Sexual frustration", "Sanity", -6),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Sexual frustration", "Sexual exhaustion", +2, true),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            } else {
                return global.ui.change.buildNotification([
                    new Change("Minor sexual frustration", "Sanity", -2),
                    new Change("Escaped the cave", "Sanity", +3),
                    new Change("Minor reprieve", "Stamina", +3),
                    new Change("Petrification after effects", "Agility", -1),
                    new Change("Petrification after effects", "Endurance", +1)
                ]);
            }
        }
    }

    function regainHateChange() {

    }

    function regainHateNote() {

    }

    this.regain = new ChangeController(id, "regain", function () {
        if (that.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            regainRelentChange();
        } else {
            regainHateChange();
        }
    }, function () {
        if (that.relent.get() === UndergroundCaveRelentChoice.ENJOY) {
            return regainRelentNote();
        } else {
            return regainHateNote();
        }
    });

    this.resistFail = new ChangeController(id, "regain", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.resistSucceed = new UndoController(id, "regain", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.avert = new UndoController(id, "avert", function () {
        global.kobold.status.mental.decrease(5, "Panicking");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Panic", "Sanity", -5)
        ]);
    });

    this.nuzzle = new ChangeController(id, "nuzzle", function () {
        global.kobold.status.mental.increase(6, "Cautious optimism");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Cautious optimism", "Sanity", +6)
        ]);
    });

    this.lick = new ChangeController(id, "lick", function () {
        global.kobold.status.physical.increase(8, "Wound healed");
        global.kobold.status.mental.increase(8, "Cautious optimism");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Wound healed", "Health", +8),
            new Change("Pain fading", "Sanity", +2),
            new Change("Cautious optimism", "Sanity", +6)
        ]);
    });

    this.doggo = new ChoiceController(id, "doggo");

    this.pet = new ChoiceController(id, "pet");

    this.scratch = new ChangeController(id, "scratch", function () {
        global.kobold.status.mental.increase(9, "Intensive petting");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Pet the basilisk", "Sanity", +5),
            new Change("Made a friend", "Sanity", +4)
        ]);
    });

    this.throat = new ChangeController(id, "throat", function () {
        global.kobold.status.mental.decrease(5, "Killing the basilisk");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Killed a vicious creature?", "Sanity", +3),
            new Change("Murdered an animal", "Sanity", -4),
            new Change("Betrayed trust", "Sanity", -4)
        ]);
    });

    this.throatLoot = new ChangeController(id, "throatLoot", function () {
        global.kobold.status.mental.increase(3, "Escaped the cave");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
        global.kobold.inventory.bag.addMisc(new BasiliskScales());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Minor reprieve", "Stamina", +3),
            new Change("Trophies", global.kobold.inventory.createItemWithTooltip(new BasiliskScales(), true), +1)
        ]);
    });

    this.fetch = new ChangeController(id, "fetch", function () {
        that.misc.weapon();
        global.kobold.status.mental.increase(6, "Awkward game of fetch");
        global.kobold.inventory.equipment.strip(SlotEnum.WEAPON);
        global.kobold.inventory.equipment.wear(new PetrifiedBranch());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Played fetch", "Sanity", +2),
            new Change("Made a friend", "Sanity", +4),
            new Change("Branch petrified", global.kobold.inventory.createItemWithTooltip(that.misc.weapon(), true), -1),
            new Change("New weapon", global.kobold.inventory.createItemWithTooltip(new PetrifiedBranch(), true), +1)
        ]);
    });

    this.feed = new ChangeController(id, "feed", function () {
        global.kobold.status.mental.increase(6, "Fed animal");
        global.kobold.inventory.bag.removeConsumable(new HeartyMeal());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Fed animal", "Sanity", +2),
            new Change("Made a friend", "Sanity", +4),
            new Change("Lost a meal", global.kobold.inventory.createItemWithTooltip(new HeartyMeal(), true), -1)
        ]);
    });

    this.prePatch = new ChoiceController(id, "prePatch");

    this.basiPatch = new ChoiceController(id, "basiPatch");

    this.basiTake = new ChangeController(id, "basiTake", function () {
        global.kobold.inventory.equipment.wear(new Eyepatch());
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Took eyepatch", global.kobold.inventory.createItemWithTooltip(new Eyepatch(), true), +1)
        ]);
    });

    this.basiLeave = new ChangeController(id, "basiLeave", function () {
        global.kobold.status.mental.decrease(1, "Left friend behind");
        global.kobold.status.stamina.increase(3, "Minor reprieve");
    }, function () {
        return global.ui.change.buildNotification([
            new Change("Escaped the cave", "Sanity", +3),
            new Change("Left behind the basilisk", "Sanity", -4),
            new Change("Minor reprieve", "Stamina", +3)
        ]);
    });

    this.fight = new ChoiceController(id, "fight");

    this.defence = new ChangeController(id, "defence", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.defencePatch = new ChoiceController(id, "defencePatch");

    this.defencePatchTake = new ChangeController(id, "defencePatchTake", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.defenceLeave = new ChangeController(id, "defenceLeave", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.offenceWin = new ChangeController(id, "offenceWin", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.offenceLoot = new ChangeController(id, "offenceLoot", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.wrestleWin = new UndoController(id, "wrestleWin", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.snap = new ChangeController(id, "snap", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.letGo = new ChangeController(id, "letGo", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.snapLeave = new ChangeController(id, "snapLeave", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.letGoLeave = new ChangeController(id, "letGoLeave", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.dominance = new UndoController(id, "dominance", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.pee = new ChangeController(id, "pee", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.oral = new ChangeController(id, "oral", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.sex = new ChangeController(id, "sex", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.dominanceLeave = new ChangeController(id, "dominanceLeave", function () {

    }, function () {
        return global.ui.change.buildNotification([
            new Change("TODO", "CHANGE", +1)
        ]);
    });

    this.preContinue = new ChoiceController(id, "preContinue");

    this.choices = {
        doggo: {
            PET: 1,
            FETCH: 2,
            FEED: 3
        }
    };

    this.fragments = {};
    this.fragments.fight = new UndergroundCaveFight(this);
    this.fragments.surface = new UndergroundCaveSurface(this); // Needs to be separate or else can't access the fragments variable itself.

    this.bgm = new AudioController(id, "res/audio/effects/cave.mp3", 70);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}
