/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoCrudeRude(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var fightId = arguments.callee.name + "ButtonOne";
    var struggleId = arguments.callee.name + "ButtonTwo";

    var toFight = new NightTwoCrudeFight(ctrl);
    var toStruggle = new NightTwoCrudeStruggle(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No matter what you say, they'll find a way to turn it against you.
                            Might as well not even [b]bother[/b] to play along.
                            Besides, if you show the group that you don't take kindly to them messing with you,
                            perhaps they'll leave you alone and find a different target to pick on.
                            Heck, given their [i]rough[/i] appearance, they might even [i]appreciate[/i] you not being a [b]total pushover[/b].
                        [/p]
                        [p]
                            Raising your voice, you loudly tell the man to [b]fuck off[/b].
                            You're not solving any disputes for a bunch of rude, inbred [b]humans[/b]!
                            Kobolds are ass kissers, huh?!
                            That's funny, coming from a race of [b]bootlickers[/b] that'd [b]suck their lord off[/b] for an extra acre of land,
                            or some food to make it through the winter!
                            If anything, [b]humans[/b] are the ass kissers, and you can't [b]wait[/b] for your kind to replace theirs as the dominant party around here!
                        [/p]
                        [p]
                            Wew.
                            You, uhh, didn't mean to go on a [i]rant[/i] like that.
                            You just wanted to throw some cuss words around to impress the drunkards, so they'd leave you alone.
                            A lifetime of [b]taking shit[/b] from their kind left you with a [b]lot[/b] of pent up frustration,
                            and you couldn't really stop yourself after you started venting some of that budding resentment.
                            Alas, the deed is done.
                            There's no going back now.
                            All you can do is [b]pray[/b] that the humans'll take your little [i]tirade[/i] as a [i]joke[/i].
                        [/p]
                        [p]
                            Sadly, that doesn't seem to be the case.
                            The group goes eerily quiet, angry eyes glaring down at you from all directions.
                            "[color=bred]I don't think you understand where you are.[/color]" the man that approached you breaks the silence,
                            his tone far more [b]hostile[/b] than before.
                            His hands travel down to his waist, and he deftly unbuckles the heavy belt keeping his pants up.
                            "[color=bred]This is a [b]human[/b] city, [b]lizard[/b].[/color]"
                        [/p]
                        [p]
                            From behind, one of the men roughly grabs your arm, cruelly and painfully twisting it.
                            You barely refrain from voicing your anguish, still attempting to keep up the [i]tough[/i] facade.
                            "[color=bred]And in Varanar, when [b]humans[/b] ask you a question, you [b]answer them[/b].[/color]"
                            Your head is pushed down, [b]forcing[/b] you to bend over forwards.
                            "[color=bred]But since you don't want to [b]talk[/b] to us...[/color]"
                            The hulking brute turns around as he speaks, lowering his trousers and his underwear simultaneously,
                            his sweat-ridden, hairy behind coming into view, buttcheeks mere inches away from your face.
                            "[color=bred]...you're just going to have to [b]show[/b] us how good you are at [b]kissing ass[/b].[/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFightChoice() {
        var disabled = ctrl.rude.has() ? "disabled" : "";
        var isSelected = ctrl.rude.get() === NightTwoCrudeRudeChoice.FIGHT;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fightId}" ${disabled}>Fight</button>`;

        var tooltip = global.parser.parse(`You're not going to go down without a fight. Come out swinging.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildStruggleChoice() {
        var disabled = ctrl.rude.has() ? "disabled" : "";
        var isSelected = ctrl.rude.get() === NightTwoCrudeRudeChoice.STRUGGLE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${struggleId}" ${disabled}>Struggle</button>`;

        var tooltip = global.parser.parse(`Struggle against the humans' grasp, but don't outright attack them.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 175px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildFightChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildStruggleChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + fightId), $("#" + struggleId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFightListener() {
        $("#" + fightId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.rude.set(NightTwoCrudeRudeChoice.FIGHT);
            loadNextPart(toFight);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerStruggleListener() {
        $("#" + struggleId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.rude.set(NightTwoCrudeRudeChoice.STRUGGLE);
            loadNextPart(toStruggle);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.lewdCrude.get() !== NightTwoCrudeChoice.RUDE) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.rude.change();
        part += buildChoice();
        part += `</div>`;
        part += toFight.build();
        part += toStruggle.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.lewdCrude.get() !== NightTwoCrudeChoice.RUDE) {
            return;
        }

        toFight.registerListeners();
        toStruggle.registerListeners();

        if (ctrl.rude.has()) {
            return;
        }

        registerFightListener();
        registerStruggleListener();
    };
}

var NightTwoCrudeRudeChoice = {
    FIGHT: 1,
    STRUGGLE: 2
};

